/*! Monio: helpers.js
    v0.51.1 (c) 2022 Kyle Simpson
    MIT License: http://getify.mit-license.org
*/
!function UMD(t,e,n,i){"function"==typeof define&&define.amd?(n=Object.values(n),define(t,n,i)):"undefined"!=typeof module&&module.exports?(n=Object.keys(n).map((t=>require(t))),module.exports=i(...n)):(n=Object.values(n).map((t=>e[t])),e[t]=i(...n))}("IOHelpers","undefined"!=typeof globalThis?globalThis:"undefined"!=typeof global?global:"undefined"!=typeof window?window:"undefined"!=typeof self?self:new Function("return this")(),{"../lib/util.js":"MonioUtil","./io.js":"IO","./all.js":"AllIO","./any.js":"AnyIO","./iox.js":"IOx","../maybe.js":"Maybe","../either.js":"Either"},(function DEF(t,e,n,i,r,o,l){"use strict";var{getMonadFlatMap:u,isFunction:f,isPromise:a,isMonad:d,liftM:O,curry:I,foldMap:s,runSignal:c}=t;listFilterInIO=I(listFilterInIO,2),listFilterOutIO=I(listFilterOutIO,2);var m=new WeakSet;let p={};function log(...t){return e((()=>console.log(...t)))}function getReader(){return e((t=>t))}function waitAll(...t){return e((e=>Promise.all(t.map((t=>liftIO(e,t).run(e))))))}function maybeFromIO(t,e={}){var n=liftIO(e,t).run(e);return a(n)?n.then(o.from):o.from(n)}function eitherFromIO(t,e={}){var n=liftIO(e,t).run(e);return a(n)?n.then((t=>l.fromFoldable(o.from(t)))):l.fromFoldable(o.from(n))}function applyIO(t,n){return e((()=>t.run(c(n))))}function doIOBind(t,n){return(...i)=>e((()=>e.do(t,...i).run(c(n))))}function doEIOBind(t,n){return(...i)=>e((()=>e.doEither(t,...i).run(c(n))))}function listFilterInIO(t,e){return listConcatIO(e.map((e=>t(e).map((t=>t?[e]:[])))))}function listFilterOutIO(t,e){return listFilterInIO((e=>iNot(t(e))),e)}function listConcatIO(t){return t.reduce(((t,e)=>t.concat(e)),e.of([]))}function match(...t){if(t.length<2)throw new Error("Invalid match arguments");for(var n=Symbol("default"),i=[];t.length>0;)if(t.length>1){let e=t.slice(0,2);t=t.slice(2),i.push(e)}else i.push([n,t[0]]),t.length=0;return e((t=>i.reduce(((i,[r,o])=>i.chain((i=>i?e.of(i):liftIO(t,r).chain(((t,i)=>r=>r?(i=f(i)?i():i,(i=Array.isArray(i)?i:[i]).reduce(((n,i)=>n.chain((n=>liftIO(t,n).chain((n=>m.has(n)?e.of(n):liftIO(t,i)))))),e.of()).chain((i=>liftIO(t,i).chain((t=>e.of(m.has(t)?t:r!==n?r:void 0)))))):e.of(r))(t,o))))),e.of()).run(c(t))))}function iif(t,e,...n){return match(t,e,...n.flatMap((t=>t)))}function elif(t,e){return[t,e]}function els(t){return[t]}function iReturn(t){return e((e=>liftIO(e,t).map((t=>{var e={returned:t};return m.add(e),e})).run(c(e))))}function iNot(t){return e((e=>liftIO(e,t).map((t=>!t)).run(c(e))))}function iAnd(...t){return e((e=>s((t=>n.fromIO(liftIO(e,t))),t).run(c(e))))}function iOr(...t){return e((e=>s((t=>i.fromIO(liftIO(e,t))),t).run(c(e))))}function wasReturned(t){return m.has(t)}function ifReturned(t){return t.map((t=>wasReturned(t)?t.returned:void 0))}function matchReturned(t){return t.map((t=>wasReturned(t)?t.returned:void 0))}function getPropIO(t,n){var i=O(n);return!e.is(i)&&f(i.fold)&&(i=i.fold(e.of,e.of)),i.map((e=>e[t]))}function assignPropIO(t,n,i){var r=O(n);!e.is(r)&&f(r.fold)&&(r=r.fold(e.of,e.of));var o=O(i);return!e.is(o)&&f(o.fold)&&(o=o.fold(e.of,e.of)),r.chain((e=>o.map((n=>n[t]=e))))}function liftIO(t,n){if(d(n)){if(e.is(n))return n;if(l.Left.is(n)||o.Nothing.is(n)){let t={returned:n};return m.add(t),e.of(t)}{let t=f(n.fold)?n.fold(e.of):u(n).call(n,e.of);return e.is(t)?t:e.of(n)}}return f(n)?liftIO(t,n(t)):n&&"object"==typeof n&&f(n.next)?e.do(n):e.of(n)}return p={log:log,getReader:getReader,waitAll:waitAll,maybeFromIO:maybeFromIO,eitherFromIO:eitherFromIO,applyIO:applyIO,doIO:e.do,doEIO:e.doEither,doIOBind:doIOBind,doEIOBind:doEIOBind,listFilterInIO:listFilterInIO,listFilterOutIO:listFilterOutIO,listConcatIO:listConcatIO,match:match,iif:iif,elif:elif,els:els,iNot:iNot,iAnd:iAnd,iOr:iOr,iReturn:iReturn,wasReturned:wasReturned,ifReturned:ifReturned,matchReturned:matchReturned,getPropIO:getPropIO,assignPropIO:assignPropIO},p.log=log,p.getReader=getReader,p.waitAll=waitAll,p.maybeFromIO=maybeFromIO,p.eitherFromIO=eitherFromIO,p.applyIO=applyIO,p.doIO=e.do,p.doEIO=e.doEither,p.doIOBind=doIOBind,p.doEIOBind=doEIOBind,p.listFilterInIO=listFilterInIO,p.listFilterOutIO=listFilterOutIO,p.listConcatIO=listConcatIO,p.match=match,p.iif=iif,p.elif=elif,p.els=els,p.iNot=iNot,p.iAnd=iAnd,p.iOr=iOr,p.iReturn=iReturn,p.wasReturned=wasReturned,p.ifReturned=ifReturned,p.matchReturned=matchReturned,p.getPropIO=getPropIO,p.assignPropIO=assignPropIO,p}));